import win32.windows;
import win32.commctrl;
import std.string;
import std.utf;
import win32frame.writek;
import win32frame.WindowObject ;
import win32frame.CommonControl;

class Progressbar : WindowObject {

  this(string name) {
    CommonControl ccex = new CommonControl() ;
    winc.lpszClassName  = toUTFz!(wchar*)(PROGRESS_CLASS) ;
    setStyle( (WS_CHILD | WS_VISIBLE ) ) ;
    super(name) ;
  }

  int getPos(){
    if( this.getHWND() != null ){
      return( cast(int)sendmsg( PBM_GETPOS, 0,0 ) ) ;
    }
    return(-1) ;
  }

  int setPos(int pos){
    if( this.getHWND() != null ){
      return( cast(int)sendmsg( PBM_SETPOS, pos, 0 ) ) ;
    }
    return(-1) ;
  }

  int setRange(int min, int max){
    if( this.getHWND() != null ){
      if( min<=max ){
        return( cast(int)sendmsg( PBM_SETRANGE32, min, max ) ) ;
      }
    }
    return(-1) ;
  }

}
