import win32.windows;
import win32.commctrl;
import std.string;
import std.utf;
import win32frame.writek;
import win32frame.WindowObject ;
import win32frame.CommonControlEx;

uint MAKELONG(ushort a, ushort b) {
        return cast(uint) ((b << 16) | a);
}

class TrackBar : WindowObject {

  this(string name) {
    CommonControlEx ccex = new CommonControlEx(ICC_COOL_CLASSES | ICC_BAR_CLASSES) ;
    winc.lpszClassName  = toUTFz!(wchar*)(TRACKBAR_CLASS) ;
    setStyle( (WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN) ) ;
    super(name) ;
  }

  int getPos(){
    return( cast(int)sendmsg( TBM_GETPOS, 0,0 ) ) ;
  }

  int setPos(int pos, bool redraw=true){
    return( cast(int)sendmsg( TBM_SETPOS, cast(int)(redraw), pos ) ) ;
  }

  int setRange(int min, int max, bool redraw=true){
    return( cast(int)sendmsg( TBM_SETRANGE, cast(int)(redraw), MAKELONG(cast(ushort)(min),cast(ushort)(max)) ) ) ;
  }

}
